-- Key-Value storage
-- (c) zöner

local KV = {}

function KV:new()
    local o = {}
    setmetatable(o, self)
    self.__index = self
    -- local map
    o.map = {}
    return o
end

-- put value
function KV:put(k,v)
    self.map[k] = v
    return self
end
-- get value
function KV:get(k,d)
    if self.map[k] == nil then return d
    else return self.map[k] end
end
-- get number
function KV:getn(k,d)
    local v = tonumber(self:get(k))
    if v ~= nil then return v
    else return d end
end
-- get boolean
function KV:getb(k,d)
    local v = self:get(k)
    if v == "true" then return true
    elseif v == "false" then return false
    else return d end
end

-- open file
function KV:open(name)
    self.name = name
    return self
end
-- close file
function KV:close()
    return self
end

-- URL decode
function KV:url_dec(s)
  s = s:gsub("+", " ")
  s = s:gsub("%%(%x%x)", function(h) return string.char(tonumber(h,16)) end)
  s = s:gsub("\r\n", "\n")
  return s
end
-- URL encode
function KV:url_enc(s)
  if (s) then
    s = s:gsub("\n", "\r\n")
    s = s:gsub("([^%w %-%_%.%~])", function(c) return string.format("%%%02X", string.byte(c)) end)
    s = s:gsub(" ", "+")
  end
  return s
end

return KV
