-- Key-Value database (via Sqlite)
-- (c) zöner

local KV     = require('kv')
local KVdb   = KV:new()
local driver = require('luasql.sqlite3')

-- open DB
function KVdb:open(name, cache)
    self.env = self.env or driver.sqlite3()
    self.name = name
    self.cache = cache == true
    self.conn = self.env:connect(name)
    self.conn:execute('CREATE TABLE IF NOT EXISTS kvp(k TEXT PRIMARY KEY, v TEXT);')
    self.conn:commit()
    return self
end
-- close DB
function KVdb:close(name)
    if self.conn ~= nil then self.conn:close() end
    if self.env ~= nil then self.env:close() end
    return self
end

-- get value from cache or DB
function KVdb:get(k,d)
    if self.conn == nil then return tostring(d)
    else
        local v = self.map[k]
        if v ~= nil then return v end
        local cur = self.conn:execute('SELECT v FROM kvp WHERE k = "' .. self.conn:escape(tostring(k)) .. '";')
        v = cur:fetch()
        if v == nil then v = tostring(d)
        elseif self.cache then self.map[tostring(k)] = tostring(v) end
        cur:close()
        return v
    end
end
-- put value to cache and DB
function KVdb:put(k,v)
    if self.conn ~= nil then
        if (not self.cache) or self.map[k] ~= v then
            if self.cache then self.map[tostring(k)] = tostring(v) end
            self.conn:execute('INSERT OR REPLACE INTO kvp(k, v) VALUES ("' ..
                self.conn:escape(tostring(k)) .. '","' .. self.conn:escape(tostring(v)) .. '");');
            self.conn:commit()
        end
    end
    return self
end

return KVdb
