-- Key-Value INI storage
-- (c) zöner

local KV = require('kv')
local KVini = KV:new()

-- open INI file
function KVini:open(name)
    self.name = name
    local f,err = io.open(name, "r+b")
    if f then
        repeat
            local l = f:read("*l")
            if l then
                local is,ie = l:find(" = ")
                if is then
                    self.map[ self:url_dec(l:sub(1,is-1)) ] = self:url_dec(l:sub(ie+1,-1))
                end
            end
        until l == nil
    end
    return self
end
-- close INI file
function KVini:close(name)
    name = name or self.name
    local f,err = io.open(name, "w+b")
    if f then
        for k,v in pairs(self.map) do
            f:write( self:url_enc(tostring(k)) .. " = " .. self:url_enc(tostring(v)) .. "\r\n" )
        end
        f:close()
    end
    return self
end

return KVini
