-- ARGV parser
-- (c) zöner

local parg = {
    named = {}, -- named parameters (e.g. key=value)
    other = {}, -- unnamed parameters
    arg   = arg,
}

-- get named parameter or default
parg.get = function(k,d)
    if parg.named[k] ~= nil then return parg.named[k]
    else return d
    end
end

-- parse parameters
for i=1,#parg.arg do
    local es,ee = parg.arg[i]:find('=')
    if es and ee and (es > 1) then
        local k = parg.arg[i]:sub(1,es-1)
        local v = parg.arg[i]:sub(ee+1,-1)
        local n = tonumber(v)
        if v == 'true' then v = true
        elseif v == 'false' then v = false
        elseif n ~= nil then v = n
        end
        parg.named[k] = v
    else
        table.insert(parg.other, parg.arg[i])
    end
end

return parg
