-- TCP communication channel
-- (c) zöner

local socket  = require('socket')
local Port    = require('port')
local PortTCP = Port:new()

function PortTCP:open(name)
    self.name = name; self.addr = name; self.port = 8080
    self:close()
    local s = socket.tcp()
    local cols,cole = name:find(':')
    if cols ~= nil then
        self.addr = name:sub(1,cols-1)
        self.port = tonumber(name:sub(cole+1,-1))
    end
    if s:connect(self.addr, self.port) then
        s:settimeout(0.01,'b')
        s:settimeout(0.01,'t')
        self.socket = s
    end
    return self
end
function PortTCP:opened() return self.socket ~= nil end
function PortTCP:close()
    if self.socket ~= nil then
        self.socket:close()
        self.socket = nil
    end
end

function PortTCP:read()
    if self:opened() then return ''
    else
        local d,e = self.socket:receive()
        if d == nil then return ''
        else return d
        end
    end
end
function PortTCP:write(data)
    if self:opened() then self.socket:send(data) end
    return self
end

return PortTCP
